.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\user32.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDELIB \masm32\lib\user32.lib
INCLUDELIB \masm32\lib\kernel32.lib

WinMain PROTO :DWORD, :DWORD, :DWORD, :DWORD

.CONST

IDR_MAINMENU  EQU   101
IDR_CHILDMENU EQU   102
IDM_EXIT      EQU 40001
IDM_TILEHORZ  EQU 40002
IDM_TILEVERT  EQU 40003
IDM_CASCADE   EQU 40004
IDM_NEW       EQU 40005
IDM_CLOSE     EQU 40006

.DATA

ClassName          DB "MDIASMClass", 0
MDIClientName      DB "MDICLIENT", 0
MDIChildClassName  DB "Win32asmMDIChild", 0
MDIChildTitle      DB "Potomek MDI", 0
AppName            DB "Przykad MDI w Win32asm", 0
ClosePromptMessage DB "Jeste pewny, e chcesz zamkn to okno?", 0

.DATA?

hInstance  DD ?
hMainMenu  DD ?
hwndClient DD ?
hChildMenu DD ?
mdicreate  MDICREATESTRUCT <>
hwndFrame  DD ?

.CODE

start:
    INVOKE GetModuleHandle, NULL
    mov    hInstance, eax
    INVOKE WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
    INVOKE ExitProcess, eax

WinMain PROC hInst:     HINSTANCE,
             hPrevInst: HINSTANCE,
             CmdLine:   LPSTR,
             CmdShow:   DWORD

LOCAL wc:  WNDCLASSEX
LOCAL msg: MSG

;=================================
; Rejestrujemy klas okna ramowego
;=================================

    mov    wc.cbSize, SIZEOF WNDCLASSEX
    mov    wc.style, CS_HREDRAW OR CS_VREDRAW
    mov    wc.lpfnWndProc, OFFSET WndProc
    mov    wc.cbClsExtra, NULL
    mov    wc.cbWndExtra, NULL
    push   hInstance
    pop    wc.hInstance
    mov    wc.hbrBackground, COLOR_APPWORKSPACE
    mov    wc.lpszMenuName, IDR_MAINMENU
    mov    wc.lpszClassName, OFFSET ClassName
    INVOKE LoadIcon, NULL, IDI_APPLICATION
    mov    wc.hIcon, eax
    mov    wc.hIconSm, eax
    INVOKE LoadCursor, NULL, IDC_ARROW
    mov    wc.hCursor, eax
    INVOKE RegisterClassEx, ADDR wc

;======================================
; Rejestrujemy klas okna potomnego MDI
;======================================

    mov    wc.lpfnWndProc, OFFSET ChildProc
    mov    wc.hbrBackground, COLOR_WINDOW+1
    mov    wc.lpszClassName, OFFSET MDIChildClassName
    INVOKE RegisterClassEx, ADDR wc
    INVOKE CreateWindowEx, NULL, ADDR ClassName, ADDR AppName,
                           WS_OVERLAPPEDWINDOW OR WS_CLIPCHILDREN,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           CW_USEDEFAULT, CW_USEDEFAULT,
                           NULL, 0, hInst, NULL
    mov    hwndFrame, eax
    INVOKE LoadMenu, hInstance, IDR_CHILDMENU
    mov    hChildMenu, eax
    INVOKE ShowWindow, hwndFrame, SW_SHOWNORMAL
    INVOKE UpdateWindow, hwndFrame

    .WHILE TRUE
        INVOKE GetMessage, ADDR msg, NULL, 0, 0
        .BREAK .IF (!eax)
        INVOKE TranslateMDISysAccel, hwndClient, ADDR msg
        .IF eax==0
            INVOKE TranslateMessage, ADDR msg
            INVOKE DispatchMessage, ADDR msg
        .ENDIF
    .ENDW

    INVOKE DestroyMenu, hChildMenu
    mov    eax, msg.wParam
    ret

WinMain ENDP

WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

LOCAL ClientStruct: CLIENTCREATESTRUCT

    .IF uMsg==WM_CREATE
        INVOKE GetMenu, hWnd
        mov    hMainMenu, eax
        INVOKE GetSubMenu, eax, 1
        mov    ClientStruct.hWindowMenu, eax
        mov    ClientStruct.idFirstChild, 100
        INVOKE CreateWindowEx, NULL, ADDR MDIClientName, NULL,
                               WS_CHILD OR WS_VISIBLE OR WS_CLIPCHILDREN,
                               CW_USEDEFAULT, CW_USEDEFAULT,
                               CW_USEDEFAULT, CW_USEDEFAULT,
                               hWnd, NULL, hInstance, ADDR ClientStruct
        mov    hwndClient, eax

;=====================================
; Inicjujemy struktur MDICREATESTRUCT
;=====================================

        mov  mdicreate.szClass, OFFSET MDIChildClassName
        mov  mdicreate.szTitle, OFFSET MDIChildTitle
        push hInstance
        pop  mdicreate.hOwner
        mov  eax, CW_USEDEFAULT
        mov  mdicreate.x, eax
        mov  mdicreate.y, eax
        mov  mdicreate.lx, eax
        mov  mdicreate.ly, eax
    .ELSEIF uMsg==WM_COMMAND
        .IF lParam==0
            mov eax, wParam
            .IF ax==IDM_EXIT
                INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
            .ELSEIF ax==IDM_TILEHORZ
                INVOKE SendMessage, hwndClient, WM_MDITILE,
                                    MDITILE_HORIZONTAL, 0
            .ELSEIF ax==IDM_TILEVERT
                INVOKE SendMessage, hwndClient, WM_MDITILE,
                                    MDITILE_VERTICAL, 0
            .ELSEIF ax==IDM_CASCADE
                INVOKE SendMessage, hwndClient, WM_MDICASCADE,
                                    MDITILE_SKIPDISABLED, 0                
            .ELSEIF ax==IDM_NEW
                INVOKE SendMessage, hwndClient, WM_MDICREATE,
                                    0, ADDR mdicreate
            .ELSEIF ax==IDM_CLOSE
                INVOKE SendMessage, hwndClient, WM_MDIGETACTIVE, 0, 0
                INVOKE SendMessage, eax, WM_CLOSE, 0, 0
            .ELSE
                INVOKE DefFrameProc, hWnd, hwndClient, uMsg, wParam, lParam        
                ret
            .ENDIF
        .ENDIF
    .ELSEIF uMsg==WM_DESTROY
        INVOKE PostQuitMessage, NULL
    .ELSE
        INVOKE DefFrameProc, hWnd, hwndClient, uMsg, wParam, lParam        
        ret
    .ENDIF

    xor eax, eax
    ret

WndProc ENDP

ChildProc PROC hChild:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

    .IF uMsg==WM_MDIACTIVATE
        mov eax, lParam
        .IF eax==hChild
            INVOKE GetSubMenu, hChildMenu, 1
            mov    edx, eax
            INVOKE SendMessage, hwndClient, WM_MDISETMENU, hChildMenu, edx
        .ELSE
            INVOKE GetSubMenu, hMainMenu, 1
            mov    edx, eax
            INVOKE SendMessage, hwndClient, WM_MDISETMENU, hMainMenu, edx            
        .ENDIF
        INVOKE DrawMenuBar, hwndFrame
    .ELSEIF uMsg==WM_CLOSE
        INVOKE MessageBox, hChild, ADDR ClosePromptMessage,
                           ADDR AppName, MB_YESNO
        .IF eax==IDYES
            INVOKE SendMessage, hwndClient, WM_MDIDESTROY, hChild, 0
        .ENDIF        
    .ELSE
        INVOKE DefMDIChildProc, hChild, uMsg, wParam, lParam
        ret
    .ENDIF

    xor eax, eax
    ret

ChildProc ENDP

END start
